class: Page
Added in: v1.8
Page provides methods to interact with a single tab in a Browser, or an
extension background page in Chromium. One Browser
instance might have multiple Page instances.
This example creates a page, navigates it to a URL, and then saves a screenshot:
const { webkit } = require('copilotbrowser'); // Or 'chromium' or 'firefox'.
(async () => {
const browser = await webkit.launch();
const context = await browser.newContext();
const page = await context.newPage();
await page.goto('https://example.com');
await page.screenshot({ path: 'screenshot.png' });
await browser.close();
})();
import com.microsoft.copilotbrowser.*;
public class Example {
public static void main(String[] args) {
try (copilotbrowser copilotbrowser = copilotbrowser.create()) {
BrowserType webkit = copilotbrowser.webkit();
Browser browser = webkit.launch();
BrowserContext context = browser.newContext();
Page page = context.newPage();
page.navigate("https://example.com");
page.screenshot(new Page.ScreenshotOptions().setPath(Paths.get("screenshot.png")));
browser.close();
}
}
}
import asyncio
from copilotbrowser.async_api import async_copilotbrowser, copilotbrowser
async def run(copilotbrowser: copilotbrowser):
webkit = copilotbrowser.webkit
browser = await webkit.launch()
context = await browser.new_context()
page = await context.new_page()
await page.goto("https://example.com")
await page.screenshot(path="screenshot.png")
await browser.close()
async def main():
async with async_copilotbrowser() as copilotbrowser:
await run(copilotbrowser)
asyncio.run(main())
from copilotbrowser.sync_api import sync_copilotbrowser, copilotbrowser
def run(copilotbrowser: copilotbrowser):
webkit = copilotbrowser.webkit
browser = webkit.launch()
context = browser.new_context()
page = context.new_page()
page.goto("https://example.com")
page.screenshot(path="screenshot.png")
browser.close()
with sync_copilotbrowser() as copilotbrowser:
run(copilotbrowser)
using Microsoft.copilotbrowser;
using System.Threading.Tasks;
class PageExamples
{
public static async Task Run()
{
using var copilotbrowser = await copilotbrowser.CreateAsync();
await using var browser = await copilotbrowser.Webkit.LaunchAsync();
var page = await browser.NewPageAsync();
await page.GotoAsync("https://www.theverge.com");
await page.ScreenshotAsync(new() { Path = "theverge.png" });
}
}
The Page class emits various events (described below) which can be handled using any of Node's native
EventEmitter methods, such as on, once or
removeListener.
This example logs a message for a single page load event:
page.once('load', () => console.log('Page loaded!'));
page.onLoad(p -> System.out.println("Page loaded!"));
page.once("load", lambda: print("page loaded!"))
page.Load += (_, _) => Console.WriteLine("Page loaded!");
To unsubscribe from events use the removeListener method:
function logRequest(interceptedRequest) {
console.log('A request was made:', interceptedRequest.url());
}
page.on('request', logRequest);
// Sometime later...
page.removeListener('request', logRequest);
Consumer<Request> logRequest = interceptedRequest -> {
System.out.println("A request was made: " + interceptedRequest.url());
};
page.onRequest(logRequest);
// Sometime later...
page.offRequest(logRequest);
def log_request(intercepted_request):
print("a request was made:", intercepted_request.url)
page.on("request", log_request)
# sometime later...
page.remove_listener("request", log_request)
void PageLoadHandler(object _, IPage p) {
Console.WriteLine("Page loaded!");
};
page.Load += PageLoadHandler;
// Do some work...
page.Load -= PageLoadHandler;
property: Page.clock
Added in: v1.45
Type:
Clock
copilotbrowser has ability to mock clock and passage of time.
event: Page.close
Added in: v1.8
- argument: <
Page>
Emitted when the page closes.
event: Page.console
Added in: v1.8
Languages: (all)
- argument: <
ConsoleMessage>
Emitted when JavaScript within the page calls one of console API methods, e.g. console.log or console.dir.
The arguments passed into console.log are available on the ConsoleMessage event handler argument.
Usage
page.on('console', async msg => {
const values = [];
for (const arg of msg.args())
values.push(await arg.jsonValue());
console.log(...values);
});
await page.evaluate(() => console.log('hello', 5, { foo: 'bar' }));
page.onConsoleMessage(msg -> {
for (int i = 0; i < msg.args().size(); ++i)
System.out.println(i + ": " + msg.args().get(i).jsonValue());
});
page.evaluate("() => console.log('hello', 5, { foo: 'bar' })");
async def print_args(msg):
values = []
for arg in msg.args:
values.append(await arg.json_value())
print(values)
page.on("console", print_args)
await page.evaluate("console.log('hello', 5, { foo: 'bar' })")
def print_args(msg):
for arg in msg.args:
print(arg.json_value())
page.on("console", print_args)
page.evaluate("console.log('hello', 5, { foo: 'bar' })")
page.Console += async (_, msg) =>
{
foreach (var arg in msg.Args)
Console.WriteLine(await arg.JsonValueAsync<object>());
};
await page.EvaluateAsync("console.log('hello', 5, { foo: 'bar' })");
event: Page.crash
Added in: v1.8
- argument: <
Page>
Emitted when the page crashes. Browser pages might crash if they try to allocate too much memory. When the page crashes, ongoing and subsequent operations will throw.
The most common way to deal with crashes is to catch an exception:
try {
// Crash might happen during a click.
await page.click('button');
// Or while waiting for an event.
await page.waitForEvent('popup');
} catch (e) {
// When the page crashes, exception message contains 'crash'.
}
try {
// Crash might happen during a click.
page.click("button");
// Or while waiting for an event.
page.waitForPopup(() -> {});
} catch (copilotbrowserException e) {
// When the page crashes, exception message contains "crash".
}
try:
# crash might happen during a click.
await page.click("button")
# or while waiting for an event.
await page.wait_for_event("popup")
except Error as e:
pass
# when the page crashes, exception message contains "crash".
try:
# crash might happen during a click.
page.click("button")
# or while waiting for an event.
page.wait_for_event("popup")
except Error as e:
pass
# when the page crashes, exception message contains "crash".
try {
// Crash might happen during a click.
await page.ClickAsync("button");
// Or while waiting for an event.
await page.WaitForPopup();
} catch (copilotbrowserException e) {
// When the page crashes, exception message contains "crash".
}
event: Page.dialog
Added in: v1.8
- argument: <
Dialog>
Emitted when a JavaScript dialog appears, such as alert, prompt, confirm or beforeunload. Listener must either Dialog.accept() or Dialog.dismiss() the dialog - otherwise the page will freeze waiting for the dialog, and actions like click will never finish.
Usage
page.on('dialog', dialog => dialog.accept());
page.onDialog(dialog -> {
dialog.accept();
});
page.on("dialog", lambda dialog: dialog.accept())
page.RequestFailed += (_, request) =>
{
Console.WriteLine(request.Url + " " + request.Failure);
};
When no Page.event('dialog') or BrowserContext.event('dialog') listeners are present, all dialogs are automatically dismissed.
event: Page.DOMContentLoaded
Added in: v1.9
- argument: <
Page>
Emitted when the JavaScript DOMContentLoaded
event is dispatched.
event: Page.download
Added in: v1.8
- argument: <
Download>
Emitted when attachment download started. User can access basic file operations on downloaded content via the passed
Download instance.
event: Page.fileChooser
Added in: v1.9
- argument: <
FileChooser>
Emitted when a file chooser is supposed to appear, such as after clicking the <input type=file>. copilotbrowser can
respond to it via setting the input files using FileChooser.setFiles() that can be uploaded after that.
page.on('filechooser', async fileChooser => {
await fileChooser.setFiles(path.join(__dirname, '/tmp/myfile.pdf'));
});
page.onFileChooser(fileChooser -> {
fileChooser.setFiles(Paths.get("/tmp/myfile.pdf"));
});
page.on("filechooser", lambda file_chooser: file_chooser.set_files("/tmp/myfile.pdf"))
page.FileChooser += (_, fileChooser) =>
{
fileChooser.SetFilesAsync(@"C:\temp\myfile.pdf");
};
event: Page.frameAttached
Added in: v1.9
- argument: <
Frame>
Emitted when a frame is attached.
event: Page.frameDetached
Added in: v1.9
- argument: <
Frame>
Emitted when a frame is detached.
event: Page.frameNavigated
Added in: v1.9
- argument: <
Frame>
Emitted when a frame is navigated to a new url.
event: Page.load
Added in: v1.8
- argument: <
Page>
Emitted when the JavaScript load event is dispatched.
event: Page.pageError
Added in: v1.9
- argument: <
Error>
Emitted when an uncaught exception happens within the page.
// Log all uncaught errors to the terminal
page.on('pageerror', exception => {
console.log(`Uncaught exception: "${exception}"`);
});
// Navigate to a page with an exception.
await page.goto('data:text/html,<script>throw new Error("Test")</script>');
// Log all uncaught errors to the terminal
page.onPageError(exception -> {
System.out.println("Uncaught exception: " + exception);
});
// Navigate to a page with an exception.
page.navigate("data:text/html,<script>throw new Error('Test')</script>");
# Log all uncaught errors to the terminal
page.on("pageerror", lambda exc: print(f"uncaught exception: {exc}"))
# Navigate to a page with an exception.
await page.goto("data:text/html,<script>throw new Error('test')</script>")
# Log all uncaught errors to the terminal
page.on("pageerror", lambda exc: print(f"uncaught exception: {exc}"))
# Navigate to a page with an exception.
page.goto("data:text/html,<script>throw new Error('test')</script>")
// Log all uncaught errors to the terminal
page.PageError += (_, exception) =>
{
Console.WriteLine("Uncaught exception: " + exception);
};
event: Page.pageError
Added in: v1.9
Languages: C#, Java
- argument: <
string>
event: Page.popup
Added in: v1.8
- argument: <
Page>
Emitted when the page opens a new tab or window. This event is emitted in addition to the BrowserContext.event('page'), but only for popups relevant to this page.
The earliest moment that page is available is when it has navigated to the initial url. For example, when opening a
popup with window.open('http://example.com'), this event will fire when the network request to "http://example.com" is
done and its response has started loading in the popup. If you would like to route/listen to this network request, use BrowserContext.route() and BrowserContext.event('request') respectively instead of similar methods on the Page.
// Start waiting for popup before clicking. Note no await.
const popupPromise = page.waitForEvent('popup');
await page.getByText('open the popup').click();
const popup = await popupPromise;
console.log(await popup.evaluate('location.href'));
Page popup = page.waitForPopup(() -> {
page.getByText("open the popup").click();
});
System.out.println(popup.evaluate("location.href"));
async with page.expect_event("popup") as page_info:
await page.get_by_text("open the popup").click()
popup = await page_info.value
print(await popup.evaluate("location.href"))
with page.expect_event("popup") as page_info:
page.get_by_text("open the popup").click()
popup = page_info.value
print(popup.evaluate("location.href"))
var popup = await page.RunAndWaitForPopupAsync(async () =>
{
await page.GetByText("open the popup").ClickAsync();
});
Console.WriteLine(await popup.EvaluateAsync<string>("location.href"));
Use Page.waitForLoadState() to wait until the page gets to a particular state (you should not need it in most cases).
event: Page.request
Added in: v1.8
- argument: <
Request>
Emitted when a page issues a request. The request object is read-only. In order to intercept and mutate requests, see
Page.route() or BrowserContext.route().
event: Page.requestFailed
Added in: v1.9
- argument: <
Request>
Emitted when a request fails, for example by timing out.
page.on('requestfailed', request => {
console.log(request.url() + ' ' + request.failure().errorText);
});
page.onRequestFailed(request -> {
System.out.println(request.url() + " " + request.failure());
});
page.on("requestfailed", lambda request: print(request.url + " " + request.failure.error_text))
HTTP Error responses, such as 404 or 503, are still successful responses from HTTP standpoint, so request will complete with Page.event('requestFinished') event and not with Page.event('requestFailed'). A request will only be considered failed when the client cannot get an HTTP response from the server, e.g. due to network error net::ERR_FAILED.
event: Page.requestFinished
Added in: v1.9
- argument: <
Request>
Emitted when a request finishes successfully after downloading the response body. For a successful response, the
sequence of events is request, response and requestfinished.
event: Page.response
Added in: v1.8
- argument: <
Response>
Emitted when response status and headers are received for a request. For a successful response, the sequence of events
is request, response and requestfinished.
event: Page.webSocket
Added in: v1.9
- argument: <
WebSocket>
Emitted when WebSocket request is sent.
event: Page.worker
Added in: v1.8
- argument: <
Worker>
Emitted when a dedicated WebWorker is spawned by the page.
async method: Page.addInitScript
Added in: v1.8
Adds a script which would be evaluated in one of the following scenarios:
- Whenever the page is navigated.
- Whenever the child frame is attached or navigated. In this case, the script is evaluated in the context of the newly attached frame.
The script is evaluated after the document was created but before any of its scripts were run. This is useful to amend
the JavaScript environment, e.g. to seed Math.random.
Usage
An example of overriding Math.random before the page loads:
// preload.js
Math.random = () => 42;
// In your copilotbrowser script, assuming the preload.js file is in same directory
await page.addInitScript({ path: './preload.js' });
await page.addInitScript(mock => {
window.mock = mock;
}, mock);
// In your copilotbrowser script, assuming the preload.js file is in same directory
page.addInitScript(Paths.get("./preload.js"));
# in your copilotbrowser script, assuming the preload.js file is in same directory
await page.add_init_script(path="./preload.js")
# in your copilotbrowser script, assuming the preload.js file is in same directory
page.add_init_script(path="./preload.js")
await Page.AddInitScriptAsync(scriptPath: "./preload.js");
The order of evaluation of multiple scripts installed via BrowserContext.addInitScript() and Page.addInitScript() is not defined.
param: Page.addInitScript.script
Added in: v1.8
Languages: JavaScript
script<function|string|Object>path?<path> Path to the JavaScript file. Ifpathis a relative path, then it is resolved relative to the current working directory. Optional.content?<string> Raw script content. Optional.
Script to be evaluated in the page.
param: Page.addInitScript.script
Added in: v1.8
Languages: C#, Java
script<string|path>
Script to be evaluated in all pages in the browser context.
param: Page.addInitScript.arg
Added in: v1.8
Languages: JavaScript
arg?<Serializable>
Optional argument to pass to script (only supported when passing a function).
param: Page.addInitScript.path
Added in: v1.8
Languages: Python
path?<path>
Path to the JavaScript file. If path is a relative path, then it is resolved relative to the current working directory. Optional.
param: Page.addInitScript.script
Added in: v1.8
Languages: Python
script?<string>
Script to be evaluated in all pages in the browser context. Optional.
async method: Page.addScriptTag
Added in: v1.8 Returns:
ElementHandle
Adds a <script> tag into the page with the desired url or content. Returns the added tag when the script's onload
fires or when the script content was injected into frame.
option: Page.addScriptTag.url
Added in: v1.8
url<string>
URL of a script to be added.
option: Page.addScriptTag.path
Added in: v1.8
path<path>
Path to the JavaScript file to be injected into frame. If path is a relative path, then it is resolved relative to the
current working directory.
option: Page.addScriptTag.content
Added in: v1.8
content<string>
Raw JavaScript content to be injected into frame.
option: Page.addScriptTag.type
Added in: v1.8
type<string>
Script type. Use 'module' in order to load a JavaScript ES6 module. See script for more details.
async method: Page.addStyleTag
Added in: v1.8 Returns:
ElementHandle
Adds a <link rel="stylesheet"> tag into the page with the desired url or a <style type="text/css"> tag with the
content. Returns the added tag when the stylesheet's onload fires or when the CSS content was injected into frame.
option: Page.addStyleTag.url
Added in: v1.8
url<string>
URL of the <link> tag.
option: Page.addStyleTag.path
Added in: v1.8
path<path>
Path to the CSS file to be injected into frame. If path is a relative path, then it is resolved relative to the
current working directory.
option: Page.addStyleTag.content
Added in: v1.8
content<string>
Raw CSS content to be injected into frame.
async method: Page.agent
Added in: v1.58
Languages: JavaScript Returns:
PageAgent
Initialize page agent with the llm provider and cache.
option: Page.agent.cache
Added in: v1.58
cache<Object>cacheFile?<string> Cache file to use/generate code for performed actions into. Cache is not used if not specified (default).cacheOutFile?<string> When specified, generated entries are written into thecacheOutFileinstead of updating thecacheFile.
option: Page.agent.expect
Added in: v1.58
expect<Object>timeout?<int> Default timeout for expect calls in milliseconds, defaults to 5000ms.
option: Page.agent.limits
Added in: v1.58
limits<Object>maxTokens?<int> Maximum number of tokens to consume. The agentic loop will stop after input + output tokens exceed this value. Defaults to unlimited.maxActions?<int> Maximum number of agentic actions to generate, defaults to 10.maxActionRetries?<int> Maximum number retries per action, defaults to 3.
Limits to use for the agentic loop.
option: Page.agent.provider
Added in: v1.58
provider<Object>api<PageAgentAPI<"openai"|"openai-compatible"|"anthropic"|"google">> API to use.apiEndpoint?<string> Endpoint to use if different from default.apiKey<string> API key for the LLM provider.apiTimeout?<int> Amount of time to wait for the provider to respond to each request.model<string> Model identifier within the provider. Required in non-cache mode.
option: Page.agent.secrets
Added in: v1.58
secrets?<Object<string,string>>
Secrets to hide from the LLM.
option: Page.agent.systemPrompt
Added in: v1.58
systemPrompt<string>
System prompt for the agent's loop.
async method: Page.bringToFront
Added in: v1.8
Brings page to front (activates tab).
async method: Page.check
Added in: v1.8
- discouraged: Use locator-based Locator.check() instead. Read more about locators.
This method checks an element matching selector by performing the following steps:
- Find an element matching selector. If there is none, wait until a matching element is attached to the DOM.
- Ensure that matched element is a checkbox or a radio input. If not, this method throws. If the element is already checked, this method returns immediately.
- Wait for actionability checks on the matched element, unless force option is set. If the element is detached during the checks, the whole action is retried.
- Scroll the element into view if needed.
- Use Page.mouse to click in the center of the element.
- Ensure that the element is now checked. If not, this method throws.
When all steps combined have not finished during the specified timeout, this method throws a
TimeoutError. Passing zero timeout disables this.
param: Page.check.selector = %%-input-selector-%%
Added in: v1.8
option: Page.check.force = %%-input-force-%%
Added in: v1.8
option: Page.check.noWaitAfter = %%-input-no-wait-after-removed-%%
Added in: v1.8
option: Page.check.position = %%-input-position-%%
Added in: v1.11
option: Page.check.strict = %%-input-strict-%%
Added in: v1.14
option: Page.check.timeout = %%-input-timeout-%%
Added in: v1.8
option: Page.check.timeout = %%-input-timeout-js-%%
Added in: v1.8
option: Page.check.trial = %%-input-trial-%%
Added in: v1.11
async method: Page.click
Added in: v1.8
- discouraged: Use locator-based Locator.click() instead. Read more about locators.
This method clicks an element matching selector by performing the following steps:
- Find an element matching selector. If there is none, wait until a matching element is attached to the DOM.
- Wait for actionability checks on the matched element, unless force option is set. If the element is detached during the checks, the whole action is retried.
- Scroll the element into view if needed.
- Use Page.mouse to click in the center of the element, or the specified position.
- Wait for initiated navigations to either succeed or fail, unless noWaitAfter option is set.
When all steps combined have not finished during the specified timeout, this method throws a
TimeoutError. Passing zero timeout disables this.
param: Page.click.selector = %%-input-selector-%%
Added in: v1.8
option: Page.click.button = %%-input-button-%%
Added in: v1.8
option: Page.click.clickCount = %%-input-click-count-%%
Added in: v1.8
option: Page.click.delay = %%-input-down-up-delay-%%
Added in: v1.8
option: Page.click.force = %%-input-force-%%
Added in: v1.8
option: Page.click.modifiers = %%-input-modifiers-%%
Added in: v1.8
option: Page.click.noWaitAfter = %%-input-no-wait-after-%%
Added in: v1.8
option: Page.click.position = %%-input-position-%%
Added in: v1.8
option: Page.click.strict = %%-input-strict-%%
Added in: v1.14
option: Page.click.timeout = %%-input-timeout-%%
Added in: v1.8
option: Page.click.timeout = %%-input-timeout-js-%%
Added in: v1.8
option: Page.click.trial = %%-input-trial-with-modifiers-%%
Added in: v1.11
async method: Page.close
Added in: v1.8
If runBeforeUnload is false, does not run any unload handlers and waits for the page to be closed. If
runBeforeUnload is true the method will run unload handlers, but will not wait for the page to close.
By default, page.close() does not run beforeunload handlers.
if runBeforeUnload is passed as true, a beforeunload dialog might be summoned and should be handled
manually via Page.event('dialog') event.
option: Page.close.reason
Added in: v1.40
reason<string>
The reason to be reported to the operations interrupted by the page closure.
option: Page.close.runBeforeUnload
Added in: v1.8
runBeforeUnload<boolean>
Defaults to false. Whether to run the
before unload page handlers.
async method: Page.content
Added in: v1.8 Returns:
string
Gets the full HTML contents of the page, including the doctype.
method: Page.context
Added in: v1.8 Returns:
BrowserContext
Get the browser context that the page belongs to.
property: Page.coverage
Added in: v1.8
Languages: JavaScript
Type:
Coverage
Only available for Chromium atm.
Browser-specific Coverage implementation. See Coverage for more details.
async method: Page.dblclick
Added in: v1.8
- discouraged: Use locator-based Locator.dblclick() instead. Read more about locators.
Languages: (all)
This method double clicks an element matching selector by performing the following steps:
- Find an element matching selector. If there is none, wait until a matching element is attached to the DOM.
- Wait for actionability checks on the matched element, unless force option is set. If the element is detached during the checks, the whole action is retried.
- Scroll the element into view if needed.
- Use Page.mouse to double click in the center of the element, or the specified position.
When all steps combined have not finished during the specified timeout, this method throws a
TimeoutError. Passing zero timeout disables this.
page.dblclick() dispatches two click events and a single dblclick event.
param: Page.dblclick.selector = %%-input-selector-%%
Added in: v1.8
option: Page.dblclick.button = %%-input-button-%%
Added in: v1.8
option: Page.dblclick.force = %%-input-force-%%
Added in: v1.8
option: Page.dblclick.delay = %%-input-down-up-delay-%%
Added in: v1.8
option: Page.dblclick.modifiers = %%-input-modifiers-%%
Added in: v1.8
option: Page.dblclick.noWaitAfter = %%-input-no-wait-after-removed-%%
Added in: v1.8
option: Page.dblclick.position = %%-input-position-%%
Added in: v1.8
option: Page.dblclick.strict = %%-input-strict-%%
Added in: v1.14
option: Page.dblclick.timeout = %%-input-timeout-%%
Added in: v1.8
option: Page.dblclick.timeout = %%-input-timeout-js-%%
Added in: v1.8
option: Page.dblclick.trial = %%-input-trial-with-modifiers-%%
Added in: v1.11
async method: Page.dispatchEvent
Added in: v1.8
- discouraged: Use locator-based Locator.dispatchEvent() instead. Read more about locators.
The snippet below dispatches the click event on the element. Regardless of the visibility state of the element, click
is dispatched. This is equivalent to calling
element.click().
Usage
await page.dispatchEvent('button#submit', 'click');
page.dispatchEvent("button#submit", "click");
await page.dispatch_event("button#submit", "click")
page.dispatch_event("button#submit", "click")
await page.DispatchEventAsync("button#submit", "click");
Under the hood, it creates an instance of an event based on the given type, initializes it with
eventInit properties and dispatches it on the element. Events are composed, cancelable and bubble by
default.
Since eventInit is event-specific, please refer to the events documentation for the lists of initial properties:
- DeviceMotionEvent
- DeviceOrientationEvent
- DragEvent
- Event
- FocusEvent
- KeyboardEvent
- MouseEvent
- PointerEvent
- TouchEvent
- WheelEvent
You can also specify JSHandle as the property value if you want live objects to be passed into the event:
// Note you can only create DataTransfer in Chromium and Firefox
const dataTransfer = await page.evaluateHandle(() => new DataTransfer());
await page.dispatchEvent('#source', 'dragstart', { dataTransfer });
// Note you can only create DataTransfer in Chromium and Firefox
JSHandle dataTransfer = page.evaluateHandle("() => new DataTransfer()");
Map<String, Object> arg = new HashMap<>();
arg.put("dataTransfer", dataTransfer);
page.dispatchEvent("#source", "dragstart", arg);
# note you can only create data_transfer in chromium and firefox
data_transfer = await page.evaluate_handle("new DataTransfer()")
await page.dispatch_event("#source", "dragstart", { "dataTransfer": data_transfer })
# note you can only create data_transfer in chromium and firefox
data_transfer = page.evaluate_handle("new DataTransfer()")
page.dispatch_event("#source", "dragstart", { "dataTransfer": data_transfer })
var dataTransfer = await page.EvaluateHandleAsync("() => new DataTransfer()");
await page.DispatchEventAsync("#source", "dragstart", new { dataTransfer });
param: Page.dispatchEvent.selector = %%-input-selector-%%
Added in: v1.8
param: Page.dispatchEvent.type
Added in: v1.8
type<string>
DOM event type: "click", "dragstart", etc.
param: Page.dispatchEvent.eventInit
Added in: v1.8
eventInit?<EvaluationArgument>
Optional event-specific initialization properties.
option: Page.dispatchEvent.strict = %%-input-strict-%%
Added in: v1.14
option: Page.dispatchEvent.timeout = %%-input-timeout-%%
Added in: v1.8
option: Page.dispatchEvent.timeout = %%-input-timeout-js-%%
Added in: v1.8
async method: Page.dragAndDrop
Added in: v1.13
This method drags the source element to the target element.
It will first move to the source element, perform a mousedown,
then move to the target element and perform a mouseup.
Usage
await page.dragAndDrop('#source', '#target');
// or specify exact positions relative to the top-left corners of the elements:
await page.dragAndDrop('#source', '#target', {
sourcePosition: { x: 34, y: 7 },
targetPosition: { x: 10, y: 20 },
});
page.dragAndDrop("#source", "#target");
// or specify exact positions relative to the top-left corners of the elements:
page.dragAndDrop("#source", "#target", new Page.DragAndDropOptions()
.setSourcePosition(34, 7).setTargetPosition(10, 20));
await page.drag_and_drop("#source", "#target")
# or specify exact positions relative to the top-left corners of the elements:
await page.drag_and_drop(
"#source",
"#target",
source_position={"x": 34, "y": 7},
target_position={"x": 10, "y": 20}
)
page.drag_and_drop("#source", "#target")
# or specify exact positions relative to the top-left corners of the elements:
page.drag_and_drop(
"#source",
"#target",
source_position={"x": 34, "y": 7},
target_position={"x": 10, "y": 20}
)
await Page.DragAndDropAsync("#source", "#target");
// or specify exact positions relative to the top-left corners of the elements:
await Page.DragAndDropAsync("#source", "#target", new()
{
SourcePosition = new() { X = 34, Y = 7 },
TargetPosition = new() { X = 10, Y = 20 },
});
param: Page.dragAndDrop.source = %%-input-source-%%
Added in: v1.13
param: Page.dragAndDrop.target = %%-input-target-%%
Added in: v1.13
option: Page.dragAndDrop.force = %%-input-force-%%
Added in: v1.13
option: Page.dragAndDrop.noWaitAfter = %%-input-no-wait-after-removed-%%
Added in: v1.13
option: Page.dragAndDrop.strict = %%-input-strict-%%
Added in: v1.14
option: Page.dragAndDrop.timeout = %%-input-timeout-%%
Added in: v1.13
option: Page.dragAndDrop.timeout = %%-input-timeout-js-%%
Added in: v1.13
option: Page.dragAndDrop.trial = %%-input-trial-%%
Added in: v1.13
option: Page.dragAndDrop.sourcePosition = %%-input-source-position-%%
Added in: v1.14
option: Page.dragAndDrop.targetPosition = %%-input-target-position-%%
Added in: v1.14
option: Page.dragAndDrop.steps = %%-input-drag-steps-%%
Added in: v1.57
async method: Page.emulateMedia
Added in: v1.8
This method changes the CSS media type through the media argument, and/or the 'prefers-colors-scheme' media feature, using the colorScheme argument.
Usage
await page.evaluate(() => matchMedia('screen').matches);
// → true
await page.evaluate(() => matchMedia('print').matches);
// → false
await page.emulateMedia({ media: 'print' });
await page.evaluate(() => matchMedia('screen').matches);
// → false
await page.evaluate(() => matchMedia('print').matches);
// → true
await page.emulateMedia({});
await page.evaluate(() => matchMedia('screen').matches);
// → true
await page.evaluate(() => matchMedia('print').matches);
// → false
page.evaluate("() => matchMedia('screen').matches");
// → true
page.evaluate("() => matchMedia('print').matches");
// → false
page.emulateMedia(new Page.EmulateMediaOptions().setMedia(Media.PRINT));
page.evaluate("() => matchMedia('screen').matches");
// → false
page.evaluate("() => matchMedia('print').matches");
// → true
page.emulateMedia(new Page.EmulateMediaOptions());
page.evaluate("() => matchMedia('screen').matches");
// → true
page.evaluate("() => matchMedia('print').matches");
// → false
await page.evaluate("matchMedia('screen').matches")
# → True
await page.evaluate("matchMedia('print').matches")
# → False
await page.emulate_media(media="print")
await page.evaluate("matchMedia('screen').matches")
# → False
await page.evaluate("matchMedia('print').matches")
# → True
await page.emulate_media()
await page.evaluate("matchMedia('screen').matches")
# → True
await page.evaluate("matchMedia('print').matches")
# → False
page.evaluate("matchMedia('screen').matches")
# → True
page.evaluate("matchMedia('print').matches")
# → False
page.emulate_media(media="print")
page.evaluate("matchMedia('screen').matches")
# → False
page.evaluate("matchMedia('print').matches")
# → True
page.emulate_media()
page.evaluate("matchMedia('screen').matches")
# → True
page.evaluate("matchMedia('print').matches")
# → False
await page.EvaluateAsync("() => matchMedia('screen').matches");
// → true
await page.EvaluateAsync("() => matchMedia('print').matches");
// → false
await page.EmulateMediaAsync(new() { Media = Media.Print });
await page.EvaluateAsync("() => matchMedia('screen').matches");
// → false
await page.EvaluateAsync("() => matchMedia('print').matches");
// → true
await page.EmulateMediaAsync(new() { Media = Media.Screen });
await page.EvaluateAsync("() => matchMedia('screen').matches");
// → true
await page.EvaluateAsync("() => matchMedia('print').matches");
// → false
await page.emulateMedia({ colorScheme: 'dark' });
await page.evaluate(() => matchMedia('(prefers-color-scheme: dark)').matches);
// → true
await page.evaluate(() => matchMedia('(prefers-color-scheme: light)').matches);
// → false
page.emulateMedia(new Page.EmulateMediaOptions().setColorScheme(ColorScheme.DARK));
page.evaluate("() => matchMedia('(prefers-color-scheme: dark)').matches");
// → true
page.evaluate("() => matchMedia('(prefers-color-scheme: light)').matches");
// → false
await page.emulate_media(color_scheme="dark")
await page.evaluate("matchMedia('(prefers-color-scheme: dark)').matches")
# → True
await page.evaluate("matchMedia('(prefers-color-scheme: light)').matches")
# → False
page.emulate_media(color_scheme="dark")
page.evaluate("matchMedia('(prefers-color-scheme: dark)').matches")
# → True
page.evaluate("matchMedia('(prefers-color-scheme: light)').matches")
# → False
await page.EmulateMediaAsync(new() { ColorScheme = ColorScheme.Dark });
await page.EvaluateAsync("matchMedia('(prefers-color-scheme: dark)').matches");
// → true
await page.EvaluateAsync("matchMedia('(prefers-color-scheme: light)').matches");
// → false
option: Page.emulateMedia.media
Added in: v1.9
Languages: JavaScript, Java
media<null|Media<"screen"|"print">>
Changes the CSS media type of the page. The only allowed values are 'screen', 'print' and null.
Passing null disables CSS media emulation.
option: Page.emulateMedia.media
Added in: v1.9
Languages: C#, Python
media<Media<"screen"|"print"|"null">>
Changes the CSS media type of the page. The only allowed values are 'Screen', 'Print' and 'Null'.
Passing 'Null' disables CSS media emulation.
option: Page.emulateMedia.colorScheme
Added in: v1.9
Languages: JavaScript, Java
colorScheme<null|ColorScheme<"light"|"dark"|"no-preference">>
Emulates prefers-colors-scheme media feature, supported values are 'light' and 'dark'. Passing
null disables color scheme emulation. 'no-preference' is deprecated.
option: Page.emulateMedia.colorScheme
Added in: v1.9
Languages: C#, Python
colorScheme<ColorScheme<"light"|"dark"|"no-preference"|"null">>
Emulates prefers-colors-scheme media feature, supported values are 'light' and 'dark'. Passing
'Null' disables color scheme emulation. 'no-preference' is deprecated.
option: Page.emulateMedia.reducedMotion
Added in: v1.12
Languages: JavaScript, Java
reducedMotion<null|ReducedMotion<"reduce"|"no-preference">>
Emulates 'prefers-reduced-motion' media feature, supported values are 'reduce', 'no-preference'. Passing null disables reduced motion emulation.
option: Page.emulateMedia.reducedMotion
Added in: v1.12
Languages: C#, Python
reducedMotion<ReducedMotion<"reduce"|"no-preference"|"null">>
Emulates 'prefers-reduced-motion' media feature, supported values are 'reduce', 'no-preference'. Passing null disables reduced motion emulation.
option: Page.emulateMedia.forcedColors
Added in: v1.15
Languages: JavaScript, Java
forcedColors<null|ForcedColors<"active"|"none">>
Emulates 'forced-colors' media feature, supported values are 'active' and 'none'. Passing null disables forced colors emulation.
option: Page.emulateMedia.forcedColors
Added in: v1.15
Languages: C#, Python
forcedColors<ForcedColors<"active"|"none"|"null">>
option: Page.emulateMedia.contrast
Added in: v1.51
Languages: JavaScript, Java
contrast<null|Contrast<"no-preference"|"more">>
Emulates 'prefers-contrast' media feature, supported values are 'no-preference', 'more'. Passing null disables contrast emulation.
option: Page.emulateMedia.contrast
Added in: v1.51
Languages: C#, Python
contrast<Contrast<"no-preference"|"more"|"null">>
async method: Page.evalOnSelector
Added in: v1.9
- discouraged: This method does not wait for the element to pass actionability
checks and therefore can lead to the flaky tests. Use Locator.evaluate(),
other
Locatorhelper methods or web-first assertions instead.
Languages: Java, Python, C# Returns:
Serializable
The method finds an element matching the specified selector within the page and passes it as a first argument to expression. If no elements match the selector, the method throws an error. Returns the value of expression.
If expression returns a Promise, then Page.evalOnSelector() would wait for the promise to resolve and
return its value.
Usage
const searchValue = await page.$eval('#search', el => el.value);
const preloadHref = await page.$eval('link[rel=preload]', el => el.href);
const html = await page.$eval('.main-container', (e, suffix) => e.outerHTML + suffix, 'hello');
// In TypeScript, this example requires an explicit type annotation (HTMLLinkElement) on el:
const preloadHrefTS = await page.$eval('link[rel=preload]', (el: HTMLLinkElement) => el.href);
String searchValue = (String) page.evalOnSelector("#search", "el => el.value");
String preloadHref = (String) page.evalOnSelector("link[rel=preload]", "el => el.href");
String html = (String) page.evalOnSelector(".main-container", "(e, suffix) => e.outerHTML + suffix", "hello");
search_value = await page.eval_on_selector("#search", "el => el.value")
preload_href = await page.eval_on_selector("link[rel=preload]", "el => el.href")
html = await page.eval_on_selector(".main-container", "(e, suffix) => e.outer_html + suffix", "hello")
search_value = page.eval_on_selector("#search", "el => el.value")
preload_href = page.eval_on_selector("link[rel=preload]", "el => el.href")
html = page.eval_on_selector(".main-container", "(e, suffix) => e.outer_html + suffix", "hello")
var searchValue = await page.EvalOnSelectorAsync<string>("#search", "el => el.value");
var preloadHref = await page.EvalOnSelectorAsync<string>("link[rel=preload]", "el => el.href");
var html = await page.EvalOnSelectorAsync(".main-container", "(e, suffix) => e.outerHTML + suffix", "hello");
param: Page.evalOnSelector.selector = %%-query-selector-%%
Added in: v1.9
param: Page.evalOnSelector.expression = %%-evaluate-expression-%%
Added in: v1.9
param: Page.evalOnSelector.expression = %%-js-evalonselector-pagefunction-%%
Added in: v1.9
param: Page.evalOnSelector.arg
Added in: v1.9
arg?<EvaluationArgument>
Optional argument to pass to expression.
option: Page.evalOnSelector.strict = %%-input-strict-%%
Added in: v1.14
async method: Page.evalOnSelectorAll
Added in: v1.9
- discouraged: In most cases, Locator.evaluateAll(),
other
Locatorhelper methods and web-first assertions do a better job.
Languages: Java, Python, C# Returns:
Serializable
The method finds all elements matching the specified selector within the page and passes an array of matched elements as a first argument to expression. Returns the result of expression invocation.
If expression returns a Promise, then Page.evalOnSelectorAll() would wait for the promise to resolve and
return its value.
Usage
const divCounts = await page.$$eval('div', (divs, min) => divs.length >= min, 10);
boolean divCounts = (boolean) page.evalOnSelectorAll("div", "(divs, min) => divs.length >= min", 10);
div_counts = await page.eval_on_selector_all("div", "(divs, min) => divs.length >= min", 10)
div_counts = page.eval_on_selector_all("div", "(divs, min) => divs.length >= min", 10)
var divsCount = await page.EvalOnSelectorAllAsync<bool>("div", "(divs, min) => divs.length >= min", 10);
param: Page.evalOnSelectorAll.selector = %%-query-selector-%%
Added in: v1.9
param: Page.evalOnSelectorAll.expression = %%-evaluate-expression-%%
Added in: v1.9
param: Page.evalOnSelectorAll.expression = %%-js-evalonselectorall-pagefunction-%%
Added in: v1.9
param: Page.evalOnSelectorAll.arg
Added in: v1.9
arg?<EvaluationArgument>
Optional argument to pass to expression.
async method: Page.evaluate
Added in: v1.8 Returns:
Serializable
Returns the value of the expression invocation.
If the function passed to the Page.evaluate() returns a Promise, then Page.evaluate() would wait
for the promise to resolve and return its value.
If the function passed to the Page.evaluate() returns a non-Serializable value, then
Page.evaluate() resolves to undefined. copilotbrowser also supports transferring some
additional values that are not serializable by JSON: -0, NaN, Infinity, -Infinity.
Usage
Passing argument to expression:
const result = await page.evaluate(([x, y]) => {
return Promise.resolve(x * y);
}, [7, 8]);
console.log(result); // prints "56"
Object result = page.evaluate("([x, y]) => {\n" +
" return Promise.resolve(x * y);\n" +
"}", Arrays.asList(7, 8));
System.out.println(result); // prints "56"
result = await page.evaluate("([x, y]) => Promise.resolve(x * y)", [7, 8])
print(result) # prints "56"
result = page.evaluate("([x, y]) => Promise.resolve(x * y)", [7, 8])
print(result) # prints "56"
var result = await page.EvaluateAsync<int>("([x, y]) => Promise.resolve(x * y)", new[] { 7, 8 });
Console.WriteLine(result);
A string can also be passed in instead of a function:
console.log(await page.evaluate('1 + 2')); // prints "3"
const x = 10;
console.log(await page.evaluate(`1 + ${x}`)); // prints "11"
System.out.println(page.evaluate("1 + 2")); // prints "3"
print(await page.evaluate("1 + 2")) # prints "3"
x = 10
print(await page.evaluate(f"1 + {x}")) # prints "11"
print(page.evaluate("1 + 2")) # prints "3"
x = 10
print(page.evaluate(f"1 + {x}")) # prints "11"
Console.WriteLine(await page.EvaluateAsync<int>("1 + 2")); // prints "3"
ElementHandle instances can be passed as an argument to the Page.evaluate():
const bodyHandle = await page.evaluate('document.body');
const html = await page.evaluate<string, HTMLElement>(([body, suffix]) =>
body.innerHTML + suffix, [bodyHandle, 'hello']
);
await bodyHandle.dispose();
ElementHandle bodyHandle = page.evaluate("document.body");
String html = (String) page.evaluate("([body, suffix]) => body.innerHTML + suffix", Arrays.asList(bodyHandle, "hello"));
bodyHandle.dispose();
body_handle = await page.evaluate("document.body")
html = await page.evaluate("([body, suffix]) => body.innerHTML + suffix", [body_handle, "hello"])
await body_handle.dispose()
body_handle = page.evaluate("document.body")
html = page.evaluate("([body, suffix]) => body.innerHTML + suffix", [body_handle, "hello"])
body_handle.dispose()
var bodyHandle = await page.EvaluateAsync("document.body");
var html = await page.EvaluateAsync<string>("([body, suffix]) => body.innerHTML + suffix", new object [] { bodyHandle, "hello" });
await bodyHandle.DisposeAsync();
param: Page.evaluate.expression = %%-evaluate-expression-%%
Added in: v1.8
param: Page.evaluate.expression = %%-js-evaluate-pagefunction-%%
Added in: v1.8
param: Page.evaluate.arg
Added in: v1.8
arg?<EvaluationArgument>
Optional argument to pass to expression.
async method: Page.evaluateHandle
Added in: v1.8 Returns:
JSHandle
Returns the value of the expression invocation as a JSHandle.
The only difference between Page.evaluate() and Page.evaluateHandle() is that Page.evaluateHandle() returns JSHandle.
If the function passed to the Page.evaluateHandle() returns a Promise, then Page.evaluateHandle() would wait for the
promise to resolve and return its value.
Usage
// Handle for the window object.
const aWindowHandle = await page.evaluateHandle(() => Promise.resolve(window));
// Handle for the window object.
JSHandle aWindowHandle = page.evaluateHandle("() => Promise.resolve(window)");
a_window_handle = await page.evaluate_handle("Promise.resolve(window)")
a_window_handle # handle for the window object.
a_window_handle = page.evaluate_handle("Promise.resolve(window)")
a_window_handle # handle for the window object.
// Handle for the window object.
var aWindowHandle = await page.EvaluateHandleAsync("() => Promise.resolve(window)");
A string can also be passed in instead of a function:
const aHandle = await page.evaluateHandle('document'); // Handle for the 'document'
JSHandle aHandle = page.evaluateHandle("document"); // Handle for the "document".
a_handle = await page.evaluate_handle("document") # handle for the "document"
a_handle = page.evaluate_handle("document") # handle for the "document"
var docHandle = await page.EvaluateHandleAsync("document"); // Handle for the `document`
JSHandle instances can be passed as an argument to the Page.evaluateHandle():
const aHandle = await page.evaluateHandle(() => document.body);
const resultHandle = await page.evaluateHandle(body => body.innerHTML, aHandle);
console.log(await resultHandle.jsonValue());
await resultHandle.dispose();
JSHandle aHandle = page.evaluateHandle("() => document.body");
JSHandle resultHandle = page.evaluateHandle("([body, suffix]) => body.innerHTML + suffix", Arrays.asList(aHandle, "hello"));
System.out.println(resultHandle.jsonValue());
resultHandle.dispose();
a_handle = await page.evaluate_handle("document.body")
result_handle = await page.evaluate_handle("body => body.innerHTML", a_handle)
print(await result_handle.json_value())
await result_handle.dispose()
a_handle = page.evaluate_handle("document.body")
result_handle = page.evaluate_handle("body => body.innerHTML", a_handle)
print(result_handle.json_value())
result_handle.dispose()
var handle = await page.EvaluateHandleAsync("() => document.body");
var resultHandle = await page.EvaluateHandleAsync("([body, suffix]) => body.innerHTML + suffix", new object[] { handle, "hello" });
Console.WriteLine(await resultHandle.JsonValueAsync<string>());
await resultHandle.DisposeAsync();
param: Page.evaluateHandle.expression = %%-evaluate-expression-%%
Added in: v1.8
param: Page.evaluateHandle.expression = %%-js-evaluate-pagefunction-%%
Added in: v1.8
param: Page.evaluateHandle.arg
Added in: v1.8
arg?<EvaluationArgument>
Optional argument to pass to expression.
async method: Page.exposeBinding
Added in: v1.8
The method adds a function called name on the window object of every frame in this page. When called, the
function executes callback and returns a Promise which resolves to the return value of callback.
If the callback returns a Promise, it will be awaited.
The first argument of the callback function contains information about the caller: { browserContext: BrowserContext, page: Page, frame: Frame }.
See BrowserContext.exposeBinding() for the context-wide version.
Functions installed via Page.exposeBinding() survive navigations.
Usage
An example of exposing page URL to all frames in a page:
const { webkit } = require('copilotbrowser'); // Or 'chromium' or 'firefox'.
(async () => {
const browser = await webkit.launch({ headless: false });
const context = await browser.newContext();
const page = await context.newPage();
await page.exposeBinding('pageURL', ({ page }) => page.url());
await page.setContent(`
<script>
async function onClick() {
document.querySelector('div').textContent = await window.pageURL();
}
</script>
<button onclick="onClick()">Click me</button>
<div></div>
`);
await page.click('button');
})();
import com.microsoft.copilotbrowser.*;
public class Example {
public static void main(String[] args) {
try (copilotbrowser copilotbrowser = copilotbrowser.create()) {
BrowserType webkit = copilotbrowser.webkit();
Browser browser = webkit.launch(new BrowserType.LaunchOptions().setHeadless(false));
BrowserContext context = browser.newContext();
Page page = context.newPage();
page.exposeBinding("pageURL", (source, args) -> source.page().url());
page.setContent("<script>\n" +
" async function onClick() {\n" +
" document.querySelector('div').textContent = await window.pageURL();\n" +
" }\n" +
"</script>\n" +
"<button onclick=\"onClick()\">Click me</button>\n" +
"<div></div>");
page.click("button");
}
}
}
import asyncio
from copilotbrowser.async_api import async_copilotbrowser, copilotbrowser
async def run(copilotbrowser: copilotbrowser):
webkit = copilotbrowser.webkit
browser = await webkit.launch(headless=False)
context = await browser.new_context()
page = await context.new_page()
await page.expose_binding("pageURL", lambda source: source["page"].url)
await page.set_content("""
<script>
async function onClick() {
document.querySelector('div').textContent = await window.pageURL();
}
</script>
<button onclick="onClick()">Click me</button>
<div></div>
""")
await page.click("button")
async def main():
async with async_copilotbrowser() as copilotbrowser:
await run(copilotbrowser)
asyncio.run(main())
from copilotbrowser.sync_api import sync_copilotbrowser, copilotbrowser
def run(copilotbrowser: copilotbrowser):
webkit = copilotbrowser.webkit
browser = webkit.launch(headless=False)
context = browser.new_context()
page = context.new_page()
page.expose_binding("pageURL", lambda source: source["page"].url)
page.set_content("""
<script>
async function onClick() {
document.querySelector('div').textContent = await window.pageURL();
}
</script>
<button onclick="onClick()">Click me</button>
<div></div>
""")
page.click("button")
with sync_copilotbrowser() as copilotbrowser:
run(copilotbrowser)
using Microsoft.copilotbrowser;
using System.Threading.Tasks;
class PageExamples
{
public static async Task Main()
{
using var copilotbrowser = await copilotbrowser.CreateAsync();
await using var browser = await copilotbrowser.Webkit.LaunchAsync(new()
{
Headless = false,
});
var page = await browser.NewPageAsync();
await page.ExposeBindingAsync("pageUrl", (source) => source.Page.Url);
await page.SetContentAsync("<script>\n" +
" async function onClick() {\n" +
" document.querySelector('div').textContent = await window.pageURL();\n" +
" }\n" +
"</script>\n" +
"<button onclick=\"onClick()\">Click me</button>\n" +
"<div></div>");
await page.ClickAsync("button");
}
}
param: Page.exposeBinding.name
Added in: v1.8
name<string>
Name of the function on the window object.
param: Page.exposeBinding.callback
Added in: v1.8
callback<function>
Callback function that will be called in the copilotbrowser's context.
option: Page.exposeBinding.handle
Added in: v1.8
⚠️ Deprecated. This option will be removed in the future.
handle<boolean>
Whether to pass the argument as a handle, instead of passing by value. When passing a handle, only one argument is supported. When passing by value, multiple arguments are supported.
async method: Page.exposeFunction
Added in: v1.8
The method adds a function called name on the window object of every frame in the page. When called, the
function executes callback and returns a Promise which resolves to the return value of callback.
If the callback returns a Promise, it will be awaited.
See BrowserContext.exposeFunction() for context-wide exposed function.
Functions installed via Page.exposeFunction() survive navigations.
Usage
An example of adding a sha256 function to the page:
const { webkit } = require('copilotbrowser'); // Or 'chromium' or 'firefox'.
const crypto = require('crypto');
(async () => {
const browser = await webkit.launch({ headless: false });
const page = await browser.newPage();
await page.exposeFunction('sha256', text =>
crypto.createHash('sha256').update(text).digest('hex'),
);
await page.setContent(`
<script>
async function onClick() {
document.querySelector('div').textContent = await window.sha256('copilotbrowser');
}
</script>
<button onclick="onClick()">Click me</button>
<div></div>
`);
await page.click('button');
})();
import com.microsoft.copilotbrowser.*;
import java.nio.charset.StandardCharsets;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.Base64;
public class Example {
public static void main(String[] args) {
try (copilotbrowser copilotbrowser = copilotbrowser.create()) {
BrowserType webkit = copilotbrowser.webkit();
Browser browser = webkit.launch(new BrowserType.LaunchOptions().setHeadless(false));
Page page = browser.newPage();
page.exposeFunction("sha256", args -> {
try {
String text = (String) args[0];
MessageDigest crypto = MessageDigest.getInstance("SHA-256");
byte[] token = crypto.digest(text.getBytes(StandardCharsets.UTF_8));
return Base64.getEncoder().encodeToString(token);
} catch (NoSuchAlgorithmException e) {
return null;
}
});
page.setContent(
"<script>\n" +
" async function onClick() {\n" +
" document.querySelector('div').textContent = await window.sha256('copilotbrowser');\n" +
" }\n" +
"</script>\n" +
"<button onclick=\"onClick()\">Click me</button>\n" +
"<div></div>"
);
page.click("button");
}
}
}
import asyncio
import hashlib
from copilotbrowser.async_api import async_copilotbrowser, copilotbrowser
def sha256(text):
m = hashlib.sha256()
m.update(bytes(text, "utf8"))
return m.hexdigest()
async def run(copilotbrowser: copilotbrowser):
webkit = copilotbrowser.webkit
browser = await webkit.launch(headless=False)
page = await browser.new_page()
await page.expose_function("sha256", sha256)
await page.set_content("""
<script>
async function onClick() {
document.querySelector('div').textContent = await window.sha256('copilotbrowser');
}
</script>
<button onclick="onClick()">Click me</button>
<div></div>
""")
await page.click("button")
async def main():
async with async_copilotbrowser() as copilotbrowser:
await run(copilotbrowser)
asyncio.run(main())
import hashlib
from copilotbrowser.sync_api import sync_copilotbrowser, copilotbrowser
def sha256(text):
m = hashlib.sha256()
m.update(bytes(text, "utf8"))
return m.hexdigest()
def run(copilotbrowser: copilotbrowser):
webkit = copilotbrowser.webkit
browser = webkit.launch(headless=False)
page = browser.new_page()
page.expose_function("sha256", sha256)
page.set_content("""
<script>
async function onClick() {
document.querySelector('div').textContent = await window.sha256('copilotbrowser');
}
</script>
<button onclick="onClick()">Click me</button>
<div></div>
""")
page.click("button")
with sync_copilotbrowser() as copilotbrowser:
run(copilotbrowser)
using Microsoft.copilotbrowser;
using System;
using System.Security.Cryptography;
using System.Threading.Tasks;
class PageExamples
{
public static async Task Main()
{
using var copilotbrowser = await copilotbrowser.CreateAsync();
await using var browser = await copilotbrowser.Webkit.LaunchAsync(new()
{
Headless = false
});
var page = await browser.NewPageAsync();
await page.ExposeFunctionAsync("sha256", (string input) =>
{
return Convert.ToBase64String(
SHA256.Create().ComputeHash(System.Text.Encoding.UTF8.GetBytes(input)));
});
await page.SetContentAsync("<script>\n" +
" async function onClick() {\n" +
" document.querySelector('div').textContent = await window.sha256('copilotbrowser');\n" +
" }\n" +
"</script>\n" +
"<button onclick=\"onClick()\">Click me</button>\n" +
"<div></div>");
await page.ClickAsync("button");
Console.WriteLine(await page.TextContentAsync("div"));
}
}
param: Page.exposeFunction.name
Added in: v1.8
name<string>
Name of the function on the window object
param: Page.exposeFunction.callback
Added in: v1.8
callback<function>
Callback function which will be called in copilotbrowser's context.
async method: Page.fill
Added in: v1.8
- discouraged: Use locator-based Locator.fill() instead. Read more about locators.
This method waits for an element matching selector, waits for actionability checks, focuses the element, fills it and triggers an input event after filling. Note that you can pass an empty string to clear the input field.
If the target element is not an <input>, <textarea> or [contenteditable] element, this method throws an error. However, if the element is inside the <label> element that has an associated control, the control will be filled instead.
To send fine-grained keyboard events, use Locator.pressSequentially().
param: Page.fill.selector = %%-input-selector-%%
Added in: v1.8
param: Page.fill.value
Added in: v1.8
value<string>
Value to fill for the <input>, <textarea> or [contenteditable] element.
option: Page.fill.force = %%-input-force-%%
Added in: v1.13
option: Page.fill.noWaitAfter = %%-input-no-wait-after-removed-%%
Added in: v1.8
option: Page.fill.strict = %%-input-strict-%%
Added in: v1.14
option: Page.fill.timeout = %%-input-timeout-%%
Added in: v1.8
option: Page.fill.timeout = %%-input-timeout-js-%%
Added in: v1.8
async method: Page.focus
Added in: v1.8
- discouraged: Use locator-based Locator.focus() instead. Read more about locators.
This method fetches an element with selector and focuses it. If there's no element matching selector, the method waits until a matching element appears in the DOM.
param: Page.focus.selector = %%-input-selector-%%
Added in: v1.8
option: Page.focus.strict = %%-input-strict-%%
Added in: v1.14
option: Page.focus.timeout = %%-input-timeout-%%
Added in: v1.8
option: Page.focus.timeout = %%-input-timeout-js-%%
Added in: v1.8
method: Page.frame
Added in: v1.8 Returns:
null|Frame
Returns frame matching the specified criteria. Either name or url must be specified.
Usage
const frame = page.frame('frame-name');
Frame frame = page.frame("frame-name");
frame = page.frame(name="frame-name")
var frame = page.Frame("frame-name");
const frame = page.frame({ url: /.*domain.*/ });
Frame frame = page.frameByUrl(Pattern.compile(".*domain.*"));
frame = page.frame(url=r".*domain.*")
var frame = page.FrameByUrl(".*domain.*");
param: Page.frame.frameSelector
Added in: v1.8
Languages: JavaScript
frameSelector<string|Object>name?<string> Frame name specified in theiframe'snameattribute. Optional.url?<string|RegExp|URLPattern|function(URL):boolean> A glob pattern, regex pattern, URL pattern, or predicate receiving frame'surlas aURLobject. Optional.
Frame name or other frame lookup options.
param: Page.frame.name
Added in: v1.9
Languages: C#, Java
name<string>
Frame name specified in the iframe's name attribute.
option: Page.frame.name
Added in: v1.8
Languages: Python
name?<string>
Frame name specified in the iframe's name attribute. Optional.
option: Page.frame.url
Added in: v1.8
Languages: Python
url?<string|RegExp|function(URL):boolean>
A glob pattern, regex pattern or predicate receiving frame's url as a URL object. Optional.
method: Page.frameByUrl
Added in: v1.9
Languages: C#, Java Returns:
null|Frame
Returns frame with matching URL.
param: Page.frameByUrl.url
Added in: v1.9
Languages: C#, Java
url<string|RegExp|function(URL):boolean>
A glob pattern, regex pattern or predicate receiving frame's url as a URL object.
method: Page.frameLocator
Added in: v1.17 Returns:
FrameLocator
When working with iframes, you can create a frame locator that will enter the iframe and allow selecting elements in that iframe.
Usage
Following snippet locates element with text "Submit" in the iframe with id my-frame,
like <iframe id="my-frame">:
const locator = page.frameLocator('#my-iframe').getByText('Submit');
await locator.click();
Locator locator = page.frameLocator("#my-iframe").getByText("Submit");
locator.click();
locator = page.frame_locator("#my-iframe").get_by_text("Submit")
await locator.click()
locator = page.frame_locator("#my-iframe").get_by_text("Submit")
locator.click()
var locator = page.FrameLocator("#my-iframe").GetByText("Submit");
await locator.ClickAsync();
param: Page.frameLocator.selector = %%-find-selector-%%
Added in: v1.17
method: Page.frames
Added in: v1.8 Returns:
Array<Frame>
An array of all frames attached to the page.
async method: Page.getAttribute
Added in: v1.8
- discouraged: Use locator-based Locator.getAttribute() instead. Read more about locators.
Returns:
null|string
Returns element attribute value.
param: Page.getAttribute.selector = %%-input-selector-%%
Added in: v1.8
param: Page.getAttribute.name
Added in: v1.8
name<string>
Attribute name to get the value for.
option: Page.getAttribute.strict = %%-input-strict-%%
Added in: v1.14
option: Page.getAttribute.timeout = %%-input-timeout-%%
Added in: v1.8
option: Page.getAttribute.timeout = %%-input-timeout-js-%%
Added in: v1.8
method: Page.getByAltText
Added in: v1.27 Returns:
Locator
%%-template-locator-get-by-alt-text-%%
param: Page.getByAltText.text = %%-locator-get-by-text-text-%%
option: Page.getByAltText.exact = %%-locator-get-by-text-exact-%%
method: Page.getByLabel
Added in: v1.27 Returns:
Locator
%%-template-locator-get-by-label-text-%%
param: Page.getByLabel.text = %%-locator-get-by-text-text-%%
option: Page.getByLabel.exact = %%-locator-get-by-text-exact-%%
method: Page.getByPlaceholder
Added in: v1.27 Returns:
Locator
%%-template-locator-get-by-placeholder-text-%%
param: Page.getByPlaceholder.text = %%-locator-get-by-text-text-%%
option: Page.getByPlaceholder.exact = %%-locator-get-by-text-exact-%%
method: Page.getByRole
Added in: v1.27 Returns:
Locator
%%-template-locator-get-by-role-%%
param: Page.getByRole.role = %%-get-by-role-to-have-role-role-%%
Added in: v1.27
option: Page.getByRole.-inline- = %%-locator-get-by-role-option-list-v1.27-%%
Added in: v1.27
option: Page.getByRole.exact = %%-locator-get-by-role-option-exact-%%
method: Page.getByTestId
Added in: v1.27 Returns:
Locator
%%-template-locator-get-by-test-id-%%
param: Page.getByTestId.testId = %%-locator-get-by-test-id-test-id-%%
Added in: v1.27
method: Page.getByText
Added in: v1.27 Returns:
Locator
%%-template-locator-get-by-text-%%
param: Page.getByText.text = %%-locator-get-by-text-text-%%
option: Page.getByText.exact = %%-locator-get-by-text-exact-%%
method: Page.getByTitle
Added in: v1.27 Returns:
Locator
%%-template-locator-get-by-title-%%
param: Page.getByTitle.text = %%-locator-get-by-text-text-%%
option: Page.getByTitle.exact = %%-locator-get-by-text-exact-%%
async method: Page.goBack
Added in: v1.8 Returns:
null|Response
Returns the main resource response. In case of multiple redirects, the navigation will resolve with the response of the
last redirect. If cannot go back, returns null.
Navigate to the previous page in history.
option: Page.goBack.waitUntil = %%-navigation-wait-until-%%
Added in: v1.8
option: Page.goBack.timeout = %%-navigation-timeout-%%
Added in: v1.8
option: Page.goBack.timeout = %%-navigation-timeout-js-%%
Added in: v1.8
async method: Page.goForward
Added in: v1.8 Returns:
null|Response
Returns the main resource response. In case of multiple redirects, the navigation will resolve with the response of the
last redirect. If cannot go forward, returns null.
Navigate to the next page in history.
async method: Page.requestGC
Added in: v1.48
Request the page to perform garbage collection. Note that there is no guarantee that all unreachable objects will be collected.
This is useful to help detect memory leaks. For example, if your page has a large object 'suspect' that might be leaked, you can check that it does not leak by using a WeakRef.
// 1. In your page, save a WeakRef for the "suspect".
await page.evaluate(() => globalThis.suspectWeakRef = new WeakRef(suspect));
// 2. Request garbage collection.
await page.requestGC();
// 3. Check that weak ref does not deref to the original object.
expect(await page.evaluate(() => !globalThis.suspectWeakRef.deref())).toBe(true);
// 1. In your page, save a WeakRef for the "suspect".
page.evaluate("globalThis.suspectWeakRef = new WeakRef(suspect)");
// 2. Request garbage collection.
page.requestGC();
// 3. Check that weak ref does not deref to the original object.
assertTrue(page.evaluate("!globalThis.suspectWeakRef.deref()"));
# 1. In your page, save a WeakRef for the "suspect".
await page.evaluate("globalThis.suspectWeakRef = new WeakRef(suspect)")
# 2. Request garbage collection.
await page.request_gc()
# 3. Check that weak ref does not deref to the original object.
assert await page.evaluate("!globalThis.suspectWeakRef.deref()")
# 1. In your page, save a WeakRef for the "suspect".
page.evaluate("globalThis.suspectWeakRef = new WeakRef(suspect)")
# 2. Request garbage collection.
page.request_gc()
# 3. Check that weak ref does not deref to the original object.
assert page.evaluate("!globalThis.suspectWeakRef.deref()")
// 1. In your page, save a WeakRef for the "suspect".
await Page.EvaluateAsync("globalThis.suspectWeakRef = new WeakRef(suspect)");
// 2. Request garbage collection.
await Page.RequestGCAsync();
// 3. Check that weak ref does not deref to the original object.
Assert.True(await Page.EvaluateAsync("!globalThis.suspectWeakRef.deref()"));
option: Page.goForward.waitUntil = %%-navigation-wait-until-%%
Added in: v1.8
option: Page.goForward.timeout = %%-navigation-timeout-%%
Added in: v1.8
option: Page.goForward.timeout = %%-navigation-timeout-js-%%
Added in: v1.8
async method: Page.goto
Added in: v1.8
Languages: (all) Returns:
null|Response
Returns the main resource response. In case of multiple redirects, the navigation will resolve with the first non-redirect response.
The method will throw an error if:
- there's an SSL error (e.g. in case of self-signed certificates).
- target URL is invalid.
- the timeout is exceeded during navigation.
- the remote server does not respond or is unreachable.
- the main resource failed to load.
The method will not throw an error when any valid HTTP status code is returned by the remote server, including 404 "Not Found" and 500 "Internal Server Error". The status code for such responses can be retrieved by calling Response.status().
The method either throws an error or returns a main resource response. The only exceptions are navigation to
about:blank or navigation to the same URL with a different hash, which would succeed and return null.
Headless mode doesn't support navigation to a PDF document. See the upstream issue.
param: Page.goto.url
Added in: v1.8
url<string>
URL to navigate page to. The url should include scheme, e.g. https://.
When a Browser.newContext.baseURL via the context options was provided and the passed URL is a path,
it gets merged via the new URL() constructor.
option: Page.goto.waitUntil = %%-navigation-wait-until-%%
Added in: v1.8
option: Page.goto.timeout = %%-navigation-timeout-%%
Added in: v1.8
option: Page.goto.timeout = %%-navigation-timeout-js-%%
Added in: v1.8
option: Page.goto.referer
Added in: v1.8
referer<string>
Referer header value. If provided it will take preference over the referer header value set by Page.setExtraHTTPHeaders().
async method: Page.hover
Added in: v1.8
- discouraged: Use locator-based Locator.hover() instead. Read more about locators.
This method hovers over an element matching selector by performing the following steps:
- Find an element matching selector. If there is none, wait until a matching element is attached to the DOM.
- Wait for actionability checks on the matched element, unless force option is set. If the element is detached during the checks, the whole action is retried.
- Scroll the element into view if needed.
- Use Page.mouse to hover over the center of the element, or the specified position.
When all steps combined have not finished during the specified timeout, this method throws a
TimeoutError. Passing zero timeout disables this.
param: Page.hover.selector = %%-input-selector-%%
Added in: v1.8
option: Page.hover.force = %%-input-force-%%
Added in: v1.8
option: Page.hover.modifiers = %%-input-modifiers-%%
Added in: v1.8
option: Page.hover.position = %%-input-position-%%
Added in: v1.8
option: Page.hover.strict = %%-input-strict-%%
Added in: v1.14
option: Page.hover.timeout = %%-input-timeout-%%
Added in: v1.8
option: Page.hover.timeout = %%-input-timeout-js-%%
Added in: v1.8
option: Page.hover.trial = %%-input-trial-with-modifiers-%%
Added in: v1.11
option: Page.hover.noWaitAfter = %%-input-no-wait-after-removed-%%
Added in: v1.28
async method: Page.innerHTML
Added in: v1.8
- discouraged: Use locator-based Locator.innerHTML() instead. Read more about locators.
Returns:
string
Returns element.innerHTML.
param: Page.innerHTML.selector = %%-input-selector-%%
Added in: v1.8
option: Page.innerHTML.strict = %%-input-strict-%%
Added in: v1.14
option: Page.innerHTML.timeout = %%-input-timeout-%%
Added in: v1.8
option: Page.innerHTML.timeout = %%-input-timeout-js-%%
Added in: v1.8
async method: Page.innerText
Added in: v1.8
- discouraged: Use locator-based Locator.innerText() instead. Read more about locators.
Returns:
string
Returns element.innerText.
param: Page.innerText.selector = %%-input-selector-%%
Added in: v1.8
option: Page.innerText.strict = %%-input-strict-%%
Added in: v1.14
option: Page.innerText.timeout = %%-input-timeout-%%
Added in: v1.8
option: Page.innerText.timeout = %%-input-timeout-js-%%
Added in: v1.8
async method: Page.inputValue
Added in: v1.13
- discouraged: Use locator-based Locator.inputValue() instead. Read more about locators.
Returns:
string
Returns input.value for the selected <input> or <textarea> or <select> element.
Throws for non-input elements. However, if the element is inside the <label> element that has an associated control, returns the value of the control.
param: Page.inputValue.selector = %%-input-selector-%%
Added in: v1.13
option: Page.inputValue.strict = %%-input-strict-%%
Added in: v1.14
option: Page.inputValue.timeout = %%-input-timeout-%%
Added in: v1.13
option: Page.inputValue.timeout = %%-input-timeout-js-%%
Added in: v1.13
async method: Page.isChecked
Added in: v1.8
- discouraged: Use locator-based Locator.isChecked() instead. Read more about locators.
Returns:
boolean
Returns whether the element is checked. Throws if the element is not a checkbox or radio input.
param: Page.isChecked.selector = %%-input-selector-%%
Added in: v1.8
option: Page.isChecked.strict = %%-input-strict-%%
Added in: v1.14
option: Page.isChecked.timeout = %%-input-timeout-%%
Added in: v1.8
option: Page.isChecked.timeout = %%-input-timeout-js-%%
Added in: v1.8
method: Page.isClosed
Added in: v1.8 Returns:
boolean
Indicates that the page has been closed.
async method: Page.isDisabled
Added in: v1.8
- discouraged: Use locator-based Locator.isDisabled() instead. Read more about locators.
Returns:
boolean
Returns whether the element is disabled, the opposite of enabled.
param: Page.isDisabled.selector = %%-input-selector-%%
Added in: v1.8
option: Page.isDisabled.strict = %%-input-strict-%%
Added in: v1.14
option: Page.isDisabled.timeout = %%-input-timeout-%%
Added in: v1.8
option: Page.isDisabled.timeout = %%-input-timeout-js-%%
Added in: v1.8
async method: Page.isEditable
Added in: v1.8
- discouraged: Use locator-based Locator.isEditable() instead. Read more about locators.
Returns:
boolean
Returns whether the element is editable.
param: Page.isEditable.selector = %%-input-selector-%%
Added in: v1.8
option: Page.isEditable.strict = %%-input-strict-%%
Added in: v1.14
option: Page.isEditable.timeout = %%-input-timeout-%%
Added in: v1.8
option: Page.isEditable.timeout = %%-input-timeout-js-%%
Added in: v1.8
async method: Page.isEnabled
Added in: v1.8
- discouraged: Use locator-based Locator.isEnabled() instead. Read more about locators.
Returns:
boolean
Returns whether the element is enabled.
param: Page.isEnabled.selector = %%-input-selector-%%
Added in: v1.8
option: Page.isEnabled.strict = %%-input-strict-%%
Added in: v1.14
option: Page.isEnabled.timeout = %%-input-timeout-%%
Added in: v1.8
option: Page.isEnabled.timeout = %%-input-timeout-js-%%
Added in: v1.8
async method: Page.isHidden
Added in: v1.8
- discouraged: Use locator-based Locator.isHidden() instead. Read more about locators.
Returns:
boolean
Returns whether the element is hidden, the opposite of visible. selector that does not match any elements is considered hidden.
param: Page.isHidden.selector = %%-input-selector-%%
Added in: v1.8
option: Page.isHidden.strict = %%-input-strict-%%
Added in: v1.14
option: Page.isHidden.timeout
Added in: v1.8
⚠️ Deprecated. This option is ignored. Page.isHidden() does not wait for the element to become hidden and returns immediately.
timeout<float>
async method: Page.isVisible
Added in: v1.8
- discouraged: Use locator-based Locator.isVisible() instead. Read more about locators.
Returns:
boolean
Returns whether the element is visible. selector that does not match any elements is considered not visible.
param: Page.isVisible.selector = %%-input-selector-%%
Added in: v1.8
option: Page.isVisible.strict = %%-input-strict-%%
Added in: v1.14
option: Page.isVisible.timeout
Added in: v1.8
⚠️ Deprecated. This option is ignored. Page.isVisible() does not wait for the element to become visible and returns immediately.
timeout<float>
property: Page.keyboard
Added in: v1.8
Type:
Keyboard
async method: Page.clearConsoleMessages
Added in: v1.59
Clears all stored console messages from this page. Subsequent calls to Page.consoleMessages() will only return messages logged after the clear.
async method: Page.clearPageErrors
Added in: v1.59
Clears all stored page errors from this page. Subsequent calls to Page.pageErrors() will only return errors thrown after the clear.
async method: Page.consoleMessages
Added in: v1.56 Returns:
Array<ConsoleMessage>
Returns up to (currently) 200 last console messages from this page. See Page.event('console') for more details.
async method: Page.pageErrors
Added in: v1.56
Languages: JavaScript, Python Returns:
Array<Error>
Returns up to (currently) 200 last page errors from this page. See Page.event('pageError') for more details.
async method: Page.pageErrors
Added in: v1.56
Languages: C#, Java Returns:
Array<string>
Returns up to (currently) 200 last page errors from this page. See Page.event('pageError') for more details.
method: Page.locator
Added in: v1.14 Returns:
Locator
%%-template-locator-root-locator-%%
param: Page.locator.selector = %%-find-selector-%%
Added in: v1.14
option: Page.locator.-inline- = %%-locator-options-list-v1.14-%%
Added in: v1.14
option: Page.locator.hasNot = %%-locator-option-has-not-%%
Added in: v1.33
option: Page.locator.hasNotText = %%-locator-option-has-not-text-%%
Added in: v1.33
method: Page.mainFrame
Added in: v1.8 Returns:
Frame
The page's main frame. Page is guaranteed to have a main frame which persists during navigations.
property: Page.mouse
Added in: v1.8
Type:
Mouse
method: Page.onceDialog
Added in: v1.10
Languages: Java
Adds one-off Dialog handler. The handler will be removed immediately after next Dialog is created.
page.onceDialog(dialog -> {
dialog.accept("foo");
});
// prints 'foo'
System.out.println(page.evaluate("prompt('Enter string:')"));
// prints 'null' as the dialog will be auto-dismissed because there are no handlers.
System.out.println(page.evaluate("prompt('Enter string:')"));
This code above is equivalent to:
Consumer<Dialog> handler = new Consumer<Dialog>() {
@Override
public void accept(Dialog dialog) {
dialog.accept("foo");
page.offDialog(this);
}
};
page.onDialog(handler);
// prints 'foo'
System.out.println(page.evaluate("prompt('Enter string:')"));
// prints 'null' as the dialog will be auto-dismissed because there are no handlers.
System.out.println(page.evaluate("prompt('Enter string:')"));
param: Page.onceDialog.handler
Added in: v1.10
handler<function(Dialog)>
Receives the Dialog object, it must either Dialog.accept() or Dialog.dismiss() the dialog - otherwise
the page will freeze waiting for the dialog,
and actions like click will never finish.
async method: Page.opener
Added in: v1.8 Returns:
null|Page
Returns the opener for popup pages and null for others. If the opener has been closed already the returns null.
async method: Page.pause
Added in: v1.9
Pauses script execution. copilotbrowser will stop executing the script and wait for the user to either press the 'Resume'
button in the page overlay or to call copilotbrowser.resume() in the DevTools console.
User can inspect selectors or perform manual steps while paused. Resume will continue running the original script from the place it was paused.
This method requires copilotbrowser to be started in a headed mode, with a falsy BrowserType.launch.headless option.
async method: Page.pdf
Added in: v1.8 Returns:
Buffer
Returns the PDF buffer.
page.pdf() generates a pdf of the page with print css media. To generate a pdf with screen media, call
Page.emulateMedia() before calling page.pdf():
By default, page.pdf() generates a pdf with modified colors for printing. Use the
-webkit-print-color-adjust property to
force rendering of exact colors.
Usage
// Generates a PDF with 'screen' media type.
await page.emulateMedia({ media: 'screen' });
await page.pdf({ path: 'page.pdf' });
// Generates a PDF with "screen" media type.
page.emulateMedia(new Page.EmulateMediaOptions().setMedia(Media.SCREEN));
page.pdf(new Page.PdfOptions().setPath(Paths.get("page.pdf")));
# generates a pdf with "screen" media type.
await page.emulate_media(media="screen")
await page.pdf(path="page.pdf")
# generates a pdf with "screen" media type.
page.emulate_media(media="screen")
page.pdf(path="page.pdf")
// Generates a PDF with 'screen' media type
await page.EmulateMediaAsync(new() { Media = Media.Screen });
await page.PdfAsync(new() { Path = "page.pdf" });
The width, height, and margin options accept values labeled with units. Unlabeled values are treated as pixels.
A few examples:
page.pdf({width: 100})- prints with width set to 100 pixelspage.pdf({width: '100px'})- prints with width set to 100 pixelspage.pdf({width: '10cm'})- prints with width set to 10 centimeters.
All possible units are:
px- pixelin- inchcm- centimetermm- millimeter
The format options are:
Letter: 8.5in x 11inLegal: 8.5in x 14inTabloid: 11in x 17inLedger: 17in x 11inA0: 33.1in x 46.8inA1: 23.4in x 33.1inA2: 16.54in x 23.4inA3: 11.7in x 16.54inA4: 8.27in x 11.7inA5: 5.83in x 8.27inA6: 4.13in x 5.83in
headerTemplate and footerTemplate markup have the following limitations: > 1. Script tags inside templates are not evaluated. > 2. Page styles are not visible inside templates.
option: Page.pdf.path
Added in: v1.8
path<path>
The file path to save the PDF to. If path is a relative path, then it is resolved relative to the current working directory. If no path is provided, the PDF won't be saved to the disk.
option: Page.pdf.scale
Added in: v1.8
scale<float>
Scale of the webpage rendering. Defaults to 1. Scale amount must be between 0.1 and 2.
option: Page.pdf.displayHeaderFooter
Added in: v1.8
displayHeaderFooter<boolean>
Display header and footer. Defaults to false.
option: Page.pdf.headerTemplate
Added in: v1.8
headerTemplate<string>
HTML template for the print header. Should be valid HTML markup with following classes used to inject printing values into them:
'date'formatted print date'title'document title'url'document location'pageNumber'current page number'totalPages'total pages in the document
option: Page.pdf.footerTemplate
Added in: v1.8
footerTemplate<string>
HTML template for the print footer. Should use the same format as the headerTemplate.
option: Page.pdf.printBackground
Added in: v1.8
printBackground<boolean>
Print background graphics. Defaults to false.
option: Page.pdf.landscape
Added in: v1.8
landscape<boolean>
Paper orientation. Defaults to false.
option: Page.pdf.pageRanges
Added in: v1.8
pageRanges<string>
Paper ranges to print, e.g., '1-5, 8, 11-13'. Defaults to the empty string, which means print all pages.
option: Page.pdf.format
Added in: v1.8
format<string>
Paper format. If set, takes priority over width or height options. Defaults to 'Letter'.
option: Page.pdf.width
Added in: v1.8
Languages: JavaScript, Python
width<string|float>
Paper width, accepts values labeled with units.
option: Page.pdf.width
Added in: v1.8
Languages: C#, Java
width<string>
Paper width, accepts values labeled with units.
option: Page.pdf.height
Added in: v1.8
Languages: JavaScript, Python
height<string|float>
Paper height, accepts values labeled with units.
option: Page.pdf.height
Added in: v1.8
Languages: C#, Java
height<string>
Paper height, accepts values labeled with units.
option: Page.pdf.margin
Added in: v1.8
Languages: JavaScript, Python
margin<Object>top?<string|float> Top margin, accepts values labeled with units. Defaults to0.right?<string|float> Right margin, accepts values labeled with units. Defaults to0.bottom?<string|float> Bottom margin, accepts values labeled with units. Defaults to0.left?<string|float> Left margin, accepts values labeled with units. Defaults to0.
Paper margins, defaults to none.
option: Page.pdf.margin
Added in: v1.8
Languages: C#, Java
margin<Object>top?<string> Top margin, accepts values labeled with units. Defaults to0.right?<string> Right margin, accepts values labeled with units. Defaults to0.bottom?<string> Bottom margin, accepts values labeled with units. Defaults to0.left?<string> Left margin, accepts values labeled with units. Defaults to0.
Paper margins, defaults to none.
option: Page.pdf.preferCSSPageSize
Added in: v1.8
preferCSSPageSize<boolean>
Give any CSS @page size declared in the page priority over what is declared in width and
height or format options. Defaults to false, which will scale the content to fit the paper
size.
option: Page.pdf.tagged
Added in: v1.42
tagged<boolean>
Whether or not to generate tagged (accessible) PDF. Defaults to false.
option: Page.pdf.outline
Added in: v1.42
outline<boolean>
Whether or not to embed the document outline into the PDF. Defaults to false.
async method: Page.press
Added in: v1.8
- discouraged: Use locator-based Locator.press() instead. Read more about locators.
Focuses the element, and then uses Keyboard.down() and Keyboard.up().
key can specify the intended keyboardEvent.key value or a single character to generate the text for. A superset of the key values can be found here. Examples of the keys are:
F1 - F12, Digit0- Digit9, KeyA- KeyZ, Backquote, Minus, Equal, Backslash, Backspace, Tab,
Delete, Escape, ArrowDown, End, Enter, Home, Insert, PageDown, PageUp, ArrowRight, ArrowUp, etc.
Following modification shortcuts are also supported: Shift, Control, Alt, Meta, ShiftLeft, ControlOrMeta.
ControlOrMeta resolves to Control on Windows and Linux and to Meta on macOS.
Holding down Shift will type the text that corresponds to the key in the upper case.
If key is a single character, it is case-sensitive, so the values a and A will generate different
respective texts.
Shortcuts such as key: "Control+o", key: "Control++ or key: "Control+Shift+T" are supported as well. When specified with the
modifier, modifier is pressed and being held while the subsequent key is being pressed.
Usage
const page = await browser.newPage();
await page.goto('https://keycode.info');
await page.press('body', 'A');
await page.screenshot({ path: 'A.png' });
await page.press('body', 'ArrowLeft');
await page.screenshot({ path: 'ArrowLeft.png' });
await page.press('body', 'Shift+O');
await page.screenshot({ path: 'O.png' });
await browser.close();
Page page = browser.newPage();
page.navigate("https://keycode.info");
page.press("body", "A");
page.screenshot(new Page.ScreenshotOptions().setPath(Paths.get("A.png")));
page.press("body", "ArrowLeft");
page.screenshot(new Page.ScreenshotOptions().setPath(Paths.get("ArrowLeft.png" )));
page.press("body", "Shift+O");
page.screenshot(new Page.ScreenshotOptions().setPath(Paths.get("O.png" )));
page = await browser.new_page()
await page.goto("https://keycode.info")
await page.press("body", "A")
await page.screenshot(path="a.png")
await page.press("body", "ArrowLeft")
await page.screenshot(path="arrow_left.png")
await page.press("body", "Shift+O")
await page.screenshot(path="o.png")
await browser.close()
page = browser.new_page()
page.goto("https://keycode.info")
page.press("body", "A")
page.screenshot(path="a.png")
page.press("body", "ArrowLeft")
page.screenshot(path="arrow_left.png")
page.press("body", "Shift+O")
page.screenshot(path="o.png")
browser.close()
var page = await browser.NewPageAsync();
await page.GotoAsync("https://keycode.info");
await page.PressAsync("body", "A");
await page.ScreenshotAsync(new() { Path = "A.png" });
await page.PressAsync("body", "ArrowLeft");
await page.ScreenshotAsync(new() { Path = "ArrowLeft.png" });
await page.PressAsync("body", "Shift+O");
await page.ScreenshotAsync(new() { Path = "O.png" });
param: Page.press.selector = %%-input-selector-%%
Added in: v1.8
param: Page.press.key
Added in: v1.8
key<string>
Name of the key to press or a character to generate, such as ArrowLeft or a.
option: Page.press.delay
Added in: v1.8
delay<float>
Time to wait between keydown and keyup in milliseconds. Defaults to 0.
option: Page.press.noWaitAfter = %%-input-no-wait-after-%%
Added in: v1.8
option: Page.press.strict = %%-input-strict-%%
Added in: v1.14
option: Page.press.timeout = %%-input-timeout-%%
Added in: v1.8
option: Page.press.timeout = %%-input-timeout-js-%%
Added in: v1.8
async method: Page.querySelector
Added in: v1.9
- discouraged: Use locator-based Page.locator() instead. Read more about locators.
Languages: Java, Python, C# Returns:
null|ElementHandle
The method finds an element matching the specified selector within the page. If no elements match the selector, the
return value resolves to null. To wait for an element on the page, use Locator.waitFor().
param: Page.querySelector.selector = %%-query-selector-%%
Added in: v1.9
option: Page.querySelector.strict = %%-input-strict-%%
Added in: v1.14
async method: Page.querySelectorAll
Added in: v1.9
- discouraged: Use locator-based Page.locator() instead. Read more about locators.
Languages: Java, Python, C# Returns:
Array<ElementHandle>
The method finds all elements matching the specified selector within the page. If no elements match the selector, the
return value resolves to [].
param: Page.querySelectorAll.selector = %%-query-selector-%%
Added in: v1.9
async method: Page.requests
Added in: v1.56 Returns:
Array<Request>
Returns up to (currently) 100 last network request from this page. See Page.event('request') for more details.
Returned requests should be accessed immediately, otherwise they might be collected to prevent unbounded memory growth as new requests come in. Once collected, retrieving most information about the request is impossible.
Note that requests reported through the Page.event('request') request are not collected, so there is a trade off between efficient memory usage with Page.requests() and the amount of available information reported through Page.event('request').
async method: Page.addLocatorHandler
Added in: v1.42
When testing a web page, sometimes unexpected overlays like a "Sign up" dialog appear and block actions you want to automate, e.g. clicking a button. These overlays don't always show up in the same way or at the same time, making them tricky to handle in automated tests.
This method lets you set up a special function, called a handler, that activates when it detects that overlay is visible. The handler's job is to remove the overlay, allowing your test to continue as if the overlay wasn't there.
Things to keep in mind:
- When an overlay is shown predictably, we recommend explicitly waiting for it in your test and dismissing it as a part of your normal test flow, instead of using Page.addLocatorHandler().
- copilotbrowser checks for the overlay every time before executing or retrying an action that requires an actionability check, or before performing an auto-waiting assertion check. When overlay is visible, copilotbrowser calls the handler first, and then proceeds with the action/assertion. Note that the handler is only called when you perform an action/assertion - if the overlay becomes visible but you don't perform any actions, the handler will not be triggered.
- After executing the handler, copilotbrowser will ensure that overlay that triggered the handler is not visible anymore. You can opt-out of this behavior with noWaitAfter.
- The execution time of the handler counts towards the timeout of the action/assertion that executed the handler. If your handler takes too long, it might cause timeouts.
- You can register multiple handlers. However, only a single handler will be running at a time. Make sure the actions within a handler don't depend on another handler.
Running the handler will alter your page state mid-test. For example it will change the currently focused element and move the mouse. Make sure that actions that run after the handler are self-contained and do not rely on the focus and mouse state being unchanged.
For example, consider a test that calls Locator.focus() followed by Keyboard.press(). If your handler clicks a button between these two actions, the focused element most likely will be wrong, and key press will happen on the unexpected element. Use Locator.press() instead to avoid this problem.
Another example is a series of mouse actions, where Mouse.move() is followed by Mouse.down(). Again, when the handler runs between these two actions, the mouse position will be wrong during the mouse down. Prefer self-contained actions like Locator.click() that do not rely on the state being unchanged by a handler.
Usage
An example that closes a "Sign up to the newsletter" dialog when it appears:
// Setup the handler.
await page.addLocatorHandler(page.getByText('Sign up to the newsletter'), async () => {
await page.getByRole('button', { name: 'No thanks' }).click();
});
// Write the test as usual.
await page.goto('https://example.com');
await page.getByRole('button', { name: 'Start here' }).click();
// Setup the handler.
page.addLocatorHandler(page.getByText("Sign up to the newsletter"), () -> {
page.getByRole(AriaRole.BUTTON, new Page.GetByRoleOptions().setName("No thanks")).click();
});
// Write the test as usual.
page.navigate("https://example.com");
page.getByRole("button", Page.GetByRoleOptions().setName("Start here")).click();
# Setup the handler.
def handler():
page.get_by_role("button", name="No thanks").click()
page.add_locator_handler(page.get_by_text("Sign up to the newsletter"), handler)
# Write the test as usual.
page.goto("https://example.com")
page.get_by_role("button", name="Start here").click()
# Setup the handler.
async def handler():
await page.get_by_role("button", name="No thanks").click()
await page.add_locator_handler(page.get_by_text("Sign up to the newsletter"), handler)
# Write the test as usual.
await page.goto("https://example.com")
await page.get_by_role("button", name="Start here").click()
// Setup the handler.
await page.AddLocatorHandlerAsync(page.GetByText("Sign up to the newsletter"), async () => {
await page.GetByRole(AriaRole.Button, new() { Name = "No thanks" }).ClickAsync();
});
// Write the test as usual.
await page.GotoAsync("https://example.com");
await page.GetByRole("button", new() { Name = "Start here" }).ClickAsync();
An example that skips the "Confirm your security details" page when it is shown:
// Setup the handler.
await page.addLocatorHandler(page.getByText('Confirm your security details'), async () => {
await page.getByRole('button', { name: 'Remind me later' }).click();
});
// Write the test as usual.
await page.goto('https://example.com');
await page.getByRole('button', { name: 'Start here' }).click();
// Setup the handler.
page.addLocatorHandler(page.getByText("Confirm your security details"), () -> {
page.getByRole(AriaRole.BUTTON, new Page.GetByRoleOptions().setName("Remind me later")).click();
});
// Write the test as usual.
page.navigate("https://example.com");
page.getByRole("button", Page.GetByRoleOptions().setName("Start here")).click();
# Setup the handler.
def handler():
page.get_by_role("button", name="Remind me later").click()
page.add_locator_handler(page.get_by_text("Confirm your security details"), handler)
# Write the test as usual.
page.goto("https://example.com")
page.get_by_role("button", name="Start here").click()
# Setup the handler.
async def handler():
await page.get_by_role("button", name="Remind me later").click()
await page.add_locator_handler(page.get_by_text("Confirm your security details"), handler)
# Write the test as usual.
await page.goto("https://example.com")
await page.get_by_role("button", name="Start here").click()
// Setup the handler.
await page.AddLocatorHandlerAsync(page.GetByText("Confirm your security details"), async () => {
await page.GetByRole(AriaRole.Button, new() { Name = "Remind me later" }).ClickAsync();
});
// Write the test as usual.
await page.GotoAsync("https://example.com");
await page.GetByRole("button", new() { Name = "Start here" }).ClickAsync();
An example with a custom callback on every actionability check. It uses a <body> locator that is always visible, so the handler is called before every actionability check. It is important to specify noWaitAfter, because the handler does not hide the <body> element.
// Setup the handler.
await page.addLocatorHandler(page.locator('body'), async () => {
await page.evaluate(() => window.removeObstructionsForTestIfNeeded());
}, { noWaitAfter: true });
// Write the test as usual.
await page.goto('https://example.com');
await page.getByRole('button', { name: 'Start here' }).click();
// Setup the handler.
page.addLocatorHandler(page.locator("body"), () -> {
page.evaluate("window.removeObstructionsForTestIfNeeded()");
}, new Page.AddLocatorHandlerOptions().setNoWaitAfter(true));
// Write the test as usual.
page.navigate("https://example.com");
page.getByRole("button", Page.GetByRoleOptions().setName("Start here")).click();
# Setup the handler.
def handler():
page.evaluate("window.removeObstructionsForTestIfNeeded()")
page.add_locator_handler(page.locator("body"), handler, no_wait_after=True)
# Write the test as usual.
page.goto("https://example.com")
page.get_by_role("button", name="Start here").click()
# Setup the handler.
async def handler():
await page.evaluate("window.removeObstructionsForTestIfNeeded()")
await page.add_locator_handler(page.locator("body"), handler, no_wait_after=True)
# Write the test as usual.
await page.goto("https://example.com")
await page.get_by_role("button", name="Start here").click()
// Setup the handler.
await page.AddLocatorHandlerAsync(page.Locator("body"), async () => {
await page.EvaluateAsync("window.removeObstructionsForTestIfNeeded()");
}, new() { NoWaitAfter = true });
// Write the test as usual.
await page.GotoAsync("https://example.com");
await page.GetByRole("button", new() { Name = "Start here" }).ClickAsync();
Handler takes the original locator as an argument. You can also automatically remove the handler after a number of invocations by setting times:
await page.addLocatorHandler(page.getByLabel('Close'), async locator => {
await locator.click();
}, { times: 1 });
page.addLocatorHandler(page.getByLabel("Close"), locator -> {
locator.click();
}, new Page.AddLocatorHandlerOptions().setTimes(1));
def handler(locator):
locator.click()
page.add_locator_handler(page.get_by_label("Close"), handler, times=1)
async def handler(locator):
await locator.click()
await page.add_locator_handler(page.get_by_label("Close"), handler, times=1)
await page.AddLocatorHandlerAsync(page.GetByText("Sign up to the newsletter"), async locator => {
await locator.ClickAsync();
}, new() { Times = 1 });
param: Page.addLocatorHandler.locator
Added in: v1.42
locator<Locator>
Locator that triggers the handler.
param: Page.addLocatorHandler.handler
Languages: JavaScript, Python
Added in: v1.42
handler<function(Locator): [Promise]>
Function that should be run once locator appears. This function should get rid of the element that blocks actions like click.
param: Page.addLocatorHandler.handler
Languages: C#
Added in: v1.42
handler<function(Locator): [Promise]>
Function that should be run once locator appears. This function should get rid of the element that blocks actions like click.
param: Page.addLocatorHandler.handler
Languages: Java
Added in: v1.42
handler<function(Locator)>
Function that should be run once locator appears. This function should get rid of the element that blocks actions like click.
option: Page.addLocatorHandler.times
Added in: v1.44
times<int>
Specifies the maximum number of times this handler should be called. Unlimited by default.
option: Page.addLocatorHandler.noWaitAfter
Added in: v1.44
noWaitAfter<boolean>
By default, after calling the handler copilotbrowser will wait until the overlay becomes hidden, and only then copilotbrowser will continue with the action/assertion that triggered the handler. This option allows to opt-out of this behavior, so that overlay can stay visible after the handler has run.
async method: Page.removeAllListeners
Added in: v1.47
Languages: JavaScript
Removes all the listeners of the given type (or all registered listeners if no type given). Allows to wait for async listeners to complete or to ignore subsequent errors from these listeners.
Usage
page.on('request', async request => {
const response = await request.response();
const body = await response.body();
console.log(body.byteLength);
});
await page.goto('https://copilotbrowser.dev', { waitUntil: 'domcontentloaded' });
// Waits for all the reported 'request' events to resolve.
await page.removeAllListeners('request', { behavior: 'wait' });
param: Page.removeAllListeners.type
Added in: v1.47
type?<string>
option: Page.removeAllListeners.behavior = %%-remove-all-listeners-options-behavior-%%
Added in: v1.47
async method: Page.removeLocatorHandler
Added in: v1.44
Removes all locator handlers added by Page.addLocatorHandler() for a specific locator.
param: Page.removeLocatorHandler.locator
Added in: v1.44
locator<Locator>
Locator passed to Page.addLocatorHandler().
async method: Page.reload
Added in: v1.8 Returns:
null|Response
This method reloads the current page, in the same way as if the user had triggered a browser refresh. Returns the main resource response. In case of multiple redirects, the navigation will resolve with the response of the last redirect.
option: Page.reload.waitUntil = %%-navigation-wait-until-%%
Added in: v1.8
option: Page.reload.timeout = %%-navigation-timeout-%%
Added in: v1.8
option: Page.reload.timeout = %%-navigation-timeout-js-%%
Added in: v1.8
property: Page.request
Added in: v1.16
Languages: (all)
Type:
APIRequestContext
API testing helper associated with this page. This method returns the same instance as BrowserContext.request on the page's context. See BrowserContext.request for more details.
async method: Page.route
Added in: v1.8
Routing provides the capability to modify network requests that are made by a page.
Once routing is enabled, every request matching the url pattern will stall unless it's continued, fulfilled or aborted.
The handler will only be called for the first url if the response is a redirect.
Page.route() will not intercept requests intercepted by Service Worker. See this issue. We recommend disabling Service Workers when using request interception by setting Browser.newContext.serviceWorkers to 'block'.
Page.route() will not intercept the first request of a popup page. Use BrowserContext.route() instead.
Usage
An example of a naive handler that aborts all image requests:
const page = await browser.newPage();
await page.route('**/*.{png,jpg,jpeg}', route => route.abort());
await page.goto('https://example.com');
await browser.close();
Page page = browser.newPage();
page.route("**/*.{png,jpg,jpeg}", route -> route.abort());
page.navigate("https://example.com");
browser.close();
page = await browser.new_page()
await page.route("**/*.{png,jpg,jpeg}", lambda route: route.abort())
await page.goto("https://example.com")
await browser.close()
page = browser.new_page()
page.route("**/*.{png,jpg,jpeg}", lambda route: route.abort())
page.goto("https://example.com")
browser.close()
var page = await browser.NewPageAsync();
await page.RouteAsync("**/*.{png,jpg,jpeg}", async r => await r.AbortAsync());
await page.GotoAsync("https://www.microsoft.com");
or the same snippet using a regex pattern instead:
const page = await browser.newPage();
await page.route(/(\.png$)|(\.jpg$)/, route => route.abort());
await page.goto('https://example.com');
await browser.close();
Page page = browser.newPage();
page.route(Pattern.compile("(\\.png$)|(\\.jpg$)"),route -> route.abort());
page.navigate("https://example.com");
browser.close();
page = await browser.new_page()
await page.route(re.compile(r"(\.png$)|(\.jpg$)"), lambda route: route.abort())
await page.goto("https://example.com")
await browser.close()
page = browser.new_page()
page.route(re.compile(r"(\.png$)|(\.jpg$)"), lambda route: route.abort())
page.goto("https://example.com")
browser.close()
var page = await browser.NewPageAsync();
[...]
